/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var popupStatus = "Deactive";

function emptyElement(elm) {
    while (elm.firstChild) {
        elm.removeChild(elm.firstChild);
    }

    return elm;
}

function closePopup() {
    var divPopup = document.querySelector("#divPopup");

    divPopup.style.display = "none";
    popupStatus = "Deactive";
}

function showPopup(message, type, callbackList) {
    // Show Popup
    var divPopup = document.querySelector("#divPopup"),
        divDetail = document.querySelector("#divPopupDetail"),
        divFooter = document.querySelector("#divPopupFooter"),
        objButton;

    if (!message || !type || popupStatus === "Active") {
        return false;
    }

    switch (type) {
        case "OK":
            emptyElement(divFooter);
            objButton = document.createElement("div");
            objButton.className = "btnPopupOK";
            objButton.appendChild(document.createTextNode("OK"));
            if (callbackList && callbackList.cbOK && typeof(callbackList.cbOK) === "function") {
                objButton.addEventListener("click", function() {
                    callbackList.cbOK();
                    closePopup();
                });
            } else {
                objButton.addEventListener("click", function() {
                    closePopup();
                });
            }
            divFooter.appendChild(objButton);

            emptyElement(divDetail);
            divDetail.appendChild(document.createTextNode(message));

            divPopup.style.display = "block";
            popupStatus = "Active";

            break;
        case "OKCancel":
            emptyElement(divFooter);
            objButton = document.createElement("div");
            objButton.className = "btnPopupOKHalf";
            objButton.appendChild(document.createTextNode("OK"));
            // register OK Button
            if (callbackList && callbackList.cbOK && typeof(callbackList.cbOK) === "function") {
                objButton.addEventListener("click", function() {
                    callbackList.cbOK();
                    closePopup();
                });
            } else {
                objButton.addEventListener("click", function() {
                    closePopup();
                });
            }
            divFooter.appendChild(objButton);
            objButton = document.createElement("div");
            objButton.className = "btnPopupCancelHalf";
            objButton.appendChild(document.createTextNode("Cancel"));
            // register cancel button
            if (callbackList && callbackList.cbCancel && typeof(callbackList.cbCancel) === "function") {
                objButton.addEventListener("click", function() {
                    callbackList.cbCancel();
                    closePopup();
                });
            } else {
                objButton.addEventListener("click", function() {
                    closePopup();
                });
            }
            divFooter.appendChild(objButton);

            emptyElement(divDetail);
            divDetail.appendChild(document.createTextNode(message));

            divPopup.style.display = "block";
            popupStatus = "Active";

            break;
        default:
            emptyElement(divFooter);
            objButton = document.createElement("div");
            objButton.className = "btnPopupOK";
            objButton.appendChild(document.createTextNode("Close"));
            divFooter.appendChild(objButton);

            emptyElement(divDetail);
            divDetail.appendChild(document.createTextNode(message));

            divPopup.style.display = "block";
            popupStatus = "Active";
    }

    return true;
}

